﻿using System;
using TaleWorlds.CampaignSystem;
using TaleWorlds.Core;
using SandBox.View.Map;
using System.Collections.Generic;
using TaleWorlds.CampaignSystem.Extensions;

namespace Tutelage
{
    public class TutelageBehavior : CampaignBehaviorBase
    {
        //mainChrracter = Hero.MainHero
        public override void RegisterEvents()
        {
            CampaignEvents.DailyTickEvent.AddNonSerializedListener(this, DailyActions);
        }

        //Declare Variables
        private void DailyActions()
        {
            Dictionary<string, Hero> dictOfValidTutelageTargets = BuildClanHeroes();
            Dictionary<SkillObject, int> maxSkillMap = BuildMaxSkillsDictionary();

            foreach (Hero _character in Clan.PlayerClan.Heroes)
            {
                bool _heroInSettlement = (Hero.MainHero.CurrentSettlement != null);
                bool _charSettlementChecker = (_character.StayingInSettlement == Hero.MainHero.CurrentSettlement);
                bool _isMCHereCheck = (_charSettlementChecker && _heroInSettlement);

                if ((_character.PartyBelongedTo != null) || (_isMCHereCheck))
                {
                    foreach(KeyValuePair<SkillObject, int> kvPair in maxSkillMap){
                        SkillObject _currentSkill = kvPair.Key;
                        int _maxValue = kvPair.Value;
                        float _skillXPGain = _maxValue / 10;

                        //do Math here
                        _character.AddSkillXp(_currentSkill, _skillXPGain);
                    }
                }
            }
        }

        Dictionary<SkillObject, int> BuildMaxSkillsDictionary()
        {
            Dictionary<SkillObject, int> maxSkillDictionary = new Dictionary<SkillObject, int>();
            foreach (Hero _character in Clan.PlayerClan.Heroes)
            {
                bool _heroInSettlement = (Hero.MainHero.CurrentSettlement != null);
                bool _charSettlementChecker = (_character.StayingInSettlement == Hero.MainHero.CurrentSettlement);
                bool _isMCHereCheck = (_charSettlementChecker && _heroInSettlement);

                //if character is in party
                if ((_character.PartyBelongedTo != null) || (_isMCHereCheck))
                {
                    foreach (SkillObject currentSkillObject in Skills.All)
                    {
                        int _maxSkillValue;
                        maxSkillDictionary.TryGetValue(currentSkillObject, out _maxSkillValue);

                        if (_character.GetSkillValue(currentSkillObject) >= _maxSkillValue)
                        {
                            _maxSkillValue = Math.Max(_character.GetSkillValue(currentSkillObject), _maxSkillValue);
                            maxSkillDictionary[currentSkillObject] = _maxSkillValue;
                        }
                    }
                }
            }
            return maxSkillDictionary;
        }

        private Dictionary<string, Hero> BuildClanHeroes()
        {
            Dictionary<string, Hero> dictionary = new Dictionary<string, Hero>();
            foreach (Hero hero in Clan.PlayerClan.Heroes)
            {
                if (hero.StayingInSettlement == Hero.MainHero.CurrentSettlement)
                {
                    dictionary.Add(hero.StringId, hero);
                } else if (hero.PartyBelongedTo != null)
                {
                    dictionary.Add(hero.StringId, hero);
                }
            }
            return dictionary;
        }



        public override void SyncData(IDataStore dataStore)
        {

        }
    }


    public class TutelageCampaignMapOnTickLogic : MapView
    {
        protected override void OnMapScreenUpdate(float dt)
        {
            base.OnMapScreenUpdate(dt);

        }
    }
}