// <auto-generated>
//   This code file has automatically been added by the "Harmony.Extensions" NuGet package (https://www.nuget.org/packages/Harmony.Extensions).
//   Please see https://github.com/BUTR/Harmony.Extensions for more information.
//
//   IMPORTANT:
//   DO NOT DELETE THIS FILE if you are using a "packages.config" file to manage your NuGet references.
//   Consider migrating to PackageReferences instead:
//   https://docs.microsoft.com/en-us/nuget/consume-packages/migrate-packages-config-to-package-reference
//   Migrating brings the following benefits:
//   * The "Harmony.Extensions" folder and the "AccessTools2.Delegate.Property.cs" file don't appear in your project.
//   * The added file is immutable and can therefore not be modified by coincidence.
//   * Updating/Uninstalling the package will work flawlessly.
// </auto-generated>

#region License
// MIT License
//
// Copyright (c) Bannerlord's Unofficial Tools & Resources
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
#endregion

using System.Reflection;

#if !HARMONYEXTENSIONS_DISABLE
#nullable enable
#if !HARMONYEXTENSIONS_ENABLEWARNINGS
#pragma warning disable
#endif

namespace HarmonyLib.BUTR.Extensions
{
    using global::System;

    /// <summary>An extension of Harmony's helper class for reflection related functions</summary>
#if !HARMONYEXTENSIONS_PUBLIC
    internal
#else
    public
#endif
        static partial class AccessTools2
    {
        public static TDelegate? GetPropertyGetterDelegate<TDelegate>(PropertyInfo propertyInfo) where TDelegate : Delegate
            => propertyInfo?.GetGetMethod(true) is { } methodInfo ? GetDelegate<TDelegate>(methodInfo) : null;

        public static TDelegate? GetPropertySetterDelegate<TDelegate>(PropertyInfo propertyInfo) where TDelegate : Delegate
            => propertyInfo?.GetSetMethod(true) is { } methodInfo ? GetDelegate<TDelegate>(methodInfo) : null;

        //
        
        public static TDelegate? GetPropertyGetterDelegate<TDelegate>(object? instance, PropertyInfo propertyInfo) where TDelegate : Delegate
            => propertyInfo?.GetGetMethod(true) is { } methodInfo ? GetDelegate<TDelegate>(instance, methodInfo) : null;

        public static TDelegate? GetPropertySetterDelegate<TDelegate>(object? instance, PropertyInfo propertyInfo) where TDelegate : Delegate
            => propertyInfo?.GetSetMethod(true) is { } methodInfo ? GetDelegate<TDelegate>(instance, methodInfo) : null;

        //

        public static TDelegate? GetDeclaredPropertyGetterDelegate<TDelegate>(Type type, string name) where TDelegate : Delegate
            => DeclaredPropertyGetter(type, name) is { } methodInfo ? GetDelegate<TDelegate>(methodInfo) : null;

        public static TDelegate? GetDeclaredPropertySetterDelegate<TDelegate>(Type type, string name) where TDelegate : Delegate
            => DeclaredPropertySetter(type, name) is { } methodInfo ? GetDelegate<TDelegate>(methodInfo) : null;
        
        public static TDelegate? GetPropertyGetterDelegate<TDelegate>(Type type, string name) where TDelegate : Delegate
            => PropertyGetter(type, name) is { } methodInfo ? GetDelegate<TDelegate>(methodInfo) : null;

        public static TDelegate? GetPropertySetterDelegate<TDelegate>(Type type, string name) where TDelegate : Delegate
            => PropertySetter(type, name) is { } methodInfo ? GetDelegate<TDelegate>(methodInfo) : null;

        //
        
        public static TDelegate? GetDeclaredPropertyGetterDelegate<TDelegate>(object? instance, Type type, string method) where TDelegate : Delegate
            => DeclaredPropertyGetter(type, method) is { } methodInfo ? GetDelegate<TDelegate>(instance, methodInfo) : null;

        public static TDelegate? GetDeclaredPropertySetterDelegate<TDelegate>(object? instance, Type type, string method) where TDelegate : Delegate
            => DeclaredPropertySetter(type, method) is { } methodInfo ? GetDelegate<TDelegate>(instance, methodInfo) : null;
        
        public static TDelegate? GetPropertyGetterDelegate<TDelegate>(object? instance, Type type, string method) where TDelegate : Delegate
            => PropertyGetter(type, method) is { } methodInfo ? GetDelegate<TDelegate>(instance, methodInfo) : null;

        public static TDelegate? GetPropertySetterDelegate<TDelegate>(object? instance, Type type, string method) where TDelegate : Delegate
            => PropertySetter(type, method) is { } methodInfo ? GetDelegate<TDelegate>(instance, methodInfo) : null;
        
        //
        
        public static TDelegate? GetDeclaredPropertyGetterDelegate<TDelegate>(string typeColonPropertyName) where TDelegate : Delegate
            => DeclaredPropertyGetter(typeColonPropertyName) is { } methodInfo ? GetDelegate<TDelegate>(methodInfo) : null;
        
        public static TDelegate? GetDeclaredPropertySetterDelegate<TDelegate>(string typeColonPropertyName) where TDelegate : Delegate
            => DeclaredPropertySetter(typeColonPropertyName) is { } methodInfo ? GetDelegate<TDelegate>(methodInfo) : null;
        
        public static TDelegate? GetPropertyGetterDelegate<TDelegate>(string typeColonPropertyName) where TDelegate : Delegate
            => PropertyGetter(typeColonPropertyName) is { } methodInfo ? GetDelegate<TDelegate>(methodInfo) : null;

        public static TDelegate? GetPropertySetterDelegate<TDelegate>(string typeColonPropertyName) where TDelegate : Delegate
            => PropertySetter(typeColonPropertyName) is { } methodInfo ? GetDelegate<TDelegate>(methodInfo) : null;

        //
        
        public static TDelegate? GetDeclaredPropertyGetterDelegate<TDelegate>(object? instance, string typeColonPropertyName) where TDelegate : Delegate
            => DeclaredPropertyGetter(typeColonPropertyName) is { } methodInfo ? GetDelegate<TDelegate>(instance, methodInfo) : null;

        public static TDelegate? GetDeclaredPropertySetterDelegate<TDelegate>(object? instance, string typeColonPropertyName) where TDelegate : Delegate
            => DeclaredPropertySetter(typeColonPropertyName) is { } methodInfo ? GetDelegate<TDelegate>(instance, methodInfo) : null;
        
        public static TDelegate? GetPropertyGetterDelegate<TDelegate>(object? instance, string typeColonPropertyName) where TDelegate : Delegate
            => PropertyGetter(typeColonPropertyName) is { } methodInfo ? GetDelegate<TDelegate>(instance, methodInfo) : null;

        public static TDelegate? GetPropertySetterDelegate<TDelegate>(object? instance, string typeColonPropertyName) where TDelegate : Delegate
            => PropertySetter(typeColonPropertyName) is { } methodInfo ? GetDelegate<TDelegate>(instance, methodInfo) : null;
        
    }
}

#pragma warning restore
#nullable restore
#endif // HARMONYEXTENSIONS_DISABLE